#!/usr/bin/env python
#-*- coding:utf-8 -*-


# Step 2: Create low resolution vector grids #################################


# options and flags
# none?


# import modules
import sys
import grass.script as grass




# Step ?: Count Pixels #############################################


##############################################################################
### input: low resolution vector gridcell, reference vector points

# grids from which to pull cats
group_of_lowres_vector_grids_raw = grass.read_command('g.mlist',\
                                    type = "vect",\
                                    pat = "pareto_grid___OVER___*___ON___*")
group_of_lowres_vector_grids = group_of_lowres_vector_grids_raw.splitlines()


# reference points to be updated with cats from gridcells
reference_points_raw = grass.read_command('g.mlist',\
                                    type = "vect",\
                                    pat = "pareto_ref_points___*")
reference_points = reference_points_raw.splitlines()


# reference coi points to be updated with cats from gridcells
reference_coi_points_raw = grass.read_command('g.mlist',\
                                    type = "vect",\
                                    pat = "pareto_ref_coi_points___*")
reference_coi_points = reference_coi_points_raw.splitlines()

### intermediate:

### output: reference pixels counted per low resolution gridcell
##############################################################################


def CountReferencePixels():
    """
    Step 3.a: Count all high resolution reference pixels\
    within each low resolution grid-cell
    """


    print """\n > Counting high resolution reference pixels within each low resolution grid-cell... (this is a timekiller :-))\n"""

    run_counter = 0
    # loop over all "reference_points" maps
    for reference_points_map in reference_points:


        print """   ===> Running process over  '%s')""" % reference_points_map


        # define counter!?
        gridcell_counter = 0


        # loop over all low resolution vector grids
        for lowres_vector_grid in group_of_lowres_vector_grids:


    # Ugly hack ##############################################################
    # check which grids should be updated for which "reference_points" map?  #
    #

            grid = lowres_vector_grid
            refchar = reference_points_map.replace("pareto_ref_points_", "")
            # -%<-- if #2 -%<---%<---%<---%<---%<---%<---%<---%<---%<---%<---

            if grid.find(refchar) > 0:

    #
    # check which grids should be updated for which "reference_points" map?  #
    ############################################################## Ugly hack #


                # add some counter
                run_counter += 1
                print "\n   * Running loop #%d" % run_counter


                # add in "reference_raster_points" maps:
                # as many "gridcell" columns as the number of vector grids

                # add "gridcell" column at reference_points, reference_coi_points
                gridcell_counter += 1
                gridcell_column = "gridcell_%d" % gridcell_counter

                grass.run_command('v.db.addcol',\
                map = reference_points_map,\
                column = "%s integer" % gridcell_column)
                print """\n     + column  "%s"  added in  '%s' """\
                 % (gridcell_column, reference_points_map)


                # carry low resolution grid-cell "CAT"s over to reference vector points
                grass.run_command('v.what.vect',\
                flags = '-v',\
                quiet = False,\
                vector = reference_points_map,\
                qvect = lowres_vector_grid,\
                column = gridcell_column,\
                qcolumn = "cat")

                # why isn't "v.what.vect" recorded in the map's history?
                grass.run_command('v.support',\
                map = reference_points_map,\
                cmdhist = """v.what.vect vector=%s column=%s qvector=%s qcolumn=cat"""\
                 % (reference_points_map, gridcell_column, lowres_vector_grid))


                print """\n     + <cat> column of  '%s'  copied over to <%s> column of  '%s'"""\
                 % (lowres_vector_grid, gridcell_column, reference_points_map)


                # check if column "total_pix" exists then skip (re-)adding it! ###
                gridtable = lowres_vector_grid
                cols = [f[0] for f in grass.db_describe(gridtable)['cols']]
                total_pix = "total_pix"


                # -%<-- if 1 -%<---%<---%<---%<---%<---%<---%<---%<---%<---%<-
                if total_pix not in cols:

                    print "     ! column <%s> does not exist in %s... !"\
                     % (total_pix, lowres_vector_grid)


                    # add "total_pix" column in low resolution vector grid
                    grass.run_command('v.db.addcol',\
                    quiet = True,\
                    map = lowres_vector_grid,\
                    column = "total_pix integer")
                    print """     + ...<%s> column added in  '%s'"""\
                     % (total_pix, lowres_vector_grid)


                    # populate "total_pix" column in low resolution vector grid
                    grass.run_command('v.db.update',\
                    quiet = False,\
                    map = lowres_vector_grid,\
                    column = total_pix,\
                    value = "(SELECT count(%s) FROM %s WHERE %s.%s=%s.cat GROUP BY %s);"\
                     % (gridcell_column,\
                      reference_points_map,\
                       reference_points_map,\
                        gridcell_column,\
                         lowres_vector_grid,\
                          gridcell_column))

                    print """     + <%s> column in  '%s'  updated from  '%s'"""\
                     % (total_pix, lowres_vector_grid, reference_points_map)
                # -%<-- if #1 -%<---%<---%<---%<---%<---%<---%<---%<---%<---%<


                print "\n   * High resolution reference pixels in  '%s'  counted"\
                 % reference_points_map
            # -%<-- if #2 -%<---%<---%<---%<---%<---%<---%<---%<---%<---%<---


        # continue to Step 3.b


def CountCoIPixels():
    """
    Step 3.b: Count CoI pixels within each low resolution gridcell
    """


#############################################################################
### input: low resolution vector grid-cell, reference CoI vector points

### intermediate:

### output: CoI pixels per low resolution grid-cell
#############################################################################


    print "\n > Counting Class of Interest pixels within each low-resolution cell... (this will take some time!)\n"

    run_counter = 0
    # loop over...
    for reference_coi_points_map in reference_coi_points:

        print """   (Running process over:  '%s' )""" % reference_coi_points_map

        # define counter !?
        gridcell_counter = 0


        # loop over...
        for lowres_vector_grid in group_of_lowres_vector_grids:


  # Ugly hack ##############################################################
    # check which grids should be updated for which "reference_points" map?  #
    #

            grid = lowres_vector_grid
            coichar = reference_coi_points_map.replace("pareto_ref_coi_points_", "")
            # -%<-- if #2 -%<---%<---%<---%<---%<---%<---%<---%<---%<---%<---

            if grid.find(coichar) > 0:

    #
    # check which grids should be updated for which "reference_points" map?  #
    ############################################################## Ugly hack #


                # add some counter
                run_counter += 1
                print "\n   * Running loop #%d" % run_counter


                # add in "reference_raster_points" maps:
                # as many "gridcell" columns as the number of vector grids

                # add gridcell column
                gridcell_counter += 1
                gridcell_column = "gridcell_%d" % gridcell_counter

                grass.run_command('v.db.addcol',\
                map = reference_coi_points_map,\
                column = "%s integer" % gridcell_column)
                print """\n     + column  "%s"  added in  '%s' """\
                 % (gridcell_column, reference_coi_points_map)


                # carry low resolution grid-cell "CAT"s over to reference-CoI vector points
                grass.run_command('v.what.vect',\
                quiet = False,\
                vector = reference_coi_points_map,\
                qvect = lowres_vector_grid,\
                column = gridcell_column,\
                qcolumn = "cat")

                # why isn't "v.what.vect" recorded in the map's history?
                grass.run_command('v.support',\
                map = reference_coi_points_map,\
                cmdhist = """v.what.vect vector=%s column=%s qvector=%s qcolumn=cat"""\
                 % (reference_coi_points_map, gridcell_column, lowres_vector_grid))


                print """\n     + <cat> column of  '%s'  copied over to <%s> column of  '%s'"""\
                 % (lowres_vector_grid, gridcell_column, reference_coi_points_map)


                # check if column "total_pix" exists then skip (re-)adding it!
                table = lowres_vector_grid
                cols = [f[0] for f in grass.db_describe(table)['cols']]
                coi_pix = "coi_pix"


                # -%<---%<---%<---%<---%<---%<---%<---%<---%<---%<---%<---%<---%<-
                if coi_pix not in cols:

                    print "     ! column <%s> does not exist in %s... !"\
                     % (coi_pix, lowres_vector_grid)


                    # add "coi_pix" column in low resolution vector grid
                    grass.run_command('v.db.addcol',\
                    quiet = True,\
                    map = lowres_vector_grid,\
                    column = "coi_pix integer")
                    print """     + ...<%s>  column added in  '%s'"""\
                     % (coi_pix, lowres_vector_grid)


                    # populate column
                    grass.run_command('v.db.update',\
                    quiet = False,\
                    map = lowres_vector_grid,\
                    column = "coi_pix",\
                    value = "(SELECT count(%s) FROM %s WHERE %s.%s=%s.cat GROUP BY %s);"\
                    % (\
                    gridcell_column,\
                     reference_coi_points_map,\
                      reference_coi_points_map,\
                       gridcell_column,\
                        lowres_vector_grid,\
                         gridcell_column))
                    print """     + <%s> column in  '%s'  updated from  '%s'"""\
                     % (coi_pix, lowres_vector_grid, reference_coi_points_map)
                # -%<---%<---%<---%<---%<---%<---%<---%<---%<---%<---%<---%<---%<-


                print "\n   * Class of Interest pixels  in  '%s'  counted"\
                 % reference_coi_points_map


# main function ##############################################################

def main():

    CountReferencePixels()


    CountCoIPixels()


    print "   * All pixels counted"


#  make it both a reusable module and a stand-alone utility
if __name__ == "__main__":
    options, flags = grass.parser()
    main()

