# Plot Accuracies


# plot pareto boundary and Oe/Ce of Classifications

	# start new graphics device

#	dev.new ( "Pareto Boundary" , width=800 , height=800 )



	# give main-title(s)

	sample_name <- "based on Landsat7 (SLC-off) samples"

	maintitle.pareto <- paste ( "Pareto boundary " , sample_name , sep = "" )

	maintitle.oe.ce <- "Omission & Commission errors of Classification techniques"



	# set-up plot "dichotomised" layout using par() ## commented out while TESTING

	old.par <- par(no.readonly=TRUE) ; on.exit(par(old.par))

#	par ( mfrow = c ( 2 , 2 ) , cex.main = 1.4 , font.axis = 1 , font.lab = 1 , cex.axis = 1 )

#	par ( cex.main = 1.4 , font.axis = 1 , font.lab = 1 , cex.axis = 1 )



	# plot Pareto boundary in first panel ;-)

	plot ( Oe.Ce.Pareto, main = maintitle.pareto , xlim = c ( 0 , 1 ) , ylim = c ( 0 , 1 ) , xlab = "Omission error" , ylab = "Commission error" , type = "b" , lwd = 1.3 )



	# add Oe/Ce for Classifications

	par ( cex = 2 , new = FALSE )

	points ( Oe.Ce.Classifications [ c ( 2 , 1 ) , ] , col = "black" , bg = c ( 0 , 1 ) , pch = c ( 2 , 25) , lwd = c ( 1 , 1 ) ) # needs bg = " "




# Plot domination regions

	# make it automatic some way!?

	# required are the coordinates of the 4 corners of the region, that is:

		# say first corner is the Oe/Ce itself: ( x = Oe , y = Ce )

		# say second corner (left-wise ;-p ) is touching the right border of the plot ( x = 1) : ( x = 1 , y = Ce )

		# say third corner (left-wise ;-p ) is the top right corner of the plot itself : ( x = 1 , y = 1 )

		# say "last" corner is touching the top border of the plot ( y = 1 ) : ( x = Oe , y = 1 )

			# a vector with the x coordinates and another one with the y coordinates is required

for ( C in ( c ( 2 , 1 ) ) ) {

# define objects

	x.C <- numeric() ; y.C <- numeric() ; xy.C <- numeric()


	# assign x coordinates

			assign (

				paste ( "x." , C , sep = "" ) ,

				c ( Oe.Ce.Classifications [ C , 1 ] , 1 , 1 , Oe.Ce.Classifications [ C , 1 ] )
			)


	# assign y coordinates

			assign (

				paste ( "y." , C , sep = "" ) ,

				c ( Oe.Ce.Classifications [ C , 2 ] , Oe.Ce.Classifications [ C , 2 ] , 1 , 1 )
			)


	# assign xy pair

			assign (

				paste ( "xy." , C , sep = "" ) ,

				cbind ( get ( paste ( "x." , C , sep = "" ) ) , get ( paste ( "y." , C , sep = "" ) ) )
			)

### Better to draw regions manually <- more control ;-)

#	# draw region

#	D <- 8

#		polygon ( get ( paste ( "xy." , C , sep = "" ) ) , density = D+4 , angle = C , col = paste ( "grey" , C , sep = "" ) )


}




# draw regions manually

	# ??? (=classification method 1)

	polygon ( xy.2 , density = 30 , angle = -45 , col = "grey10" )

	polygon ( xy.4 , density = 10 , angle = -45 , col = "grey10" )

	polygon ( xy.1 , density = 10 , angle = 45 , col = "grey10" )



	# ??? (=classification method 2)

	polygon ( xy.10 , density = 10 , angle = 45 , col = "grey10" , lty = 2 )

	polygon ( xy.7 , density = 10 , angle = 45 , col = "grey12" , lty = 2 )

	polygon ( xy.5 , density = 10 , angle = -45 , col = "grey12" , lty = 2 )




## add smartlegend

#	library(gplots)

#	par ( cex = 1 , new = FALSE )

#	smartlegend ( title = "Classification methods", x = "center" , y = "top" , legend = classification.methods.legend , y.intersp = 1.25 , col = 1 , pch = c ( 24 , 2 , 25 , 19 , 1 , 15 ) , pt.bg = c ( 1 , 0 , 1 , 0 , 0 , 0 ) , bty = "o" , bg = "gray90" )





# label points with their accuracy percentage from "highest" to "lowest"

	par ( cex = 1.15)

	text (  Oe.Ce.Classifications [ c ( 10 , 7 , 5 , 4 , 1 , 2 ) , ] , as.character ( paste ( signif ( statistics.classifications [ c ( 10 , 7 , 5 , 4 , 1 , 2 ) , "Overall Accuracy"] , digits = 4 ) , "%" , sep = "" ) ) , cex = 0.8 , pos = c ( 1 , 4 , 4 , 4 , 3 , 1 ) , offset = .65 , col = "red" ) # 10

